#include "Person.h"
#include "Student.h"
#include <iostream>
using namespace std;

int main (void)
{
	Person thisGuy("Joe", "Smith", 19, 9.5);
	Person *thatPtr = new Person("Mary", "Jones", 20, 6);

	cout << "This guy: " << thisGuy << endl;
	cout << "That pointer: " << *thatPtr << endl;

	Student thisStudent ("Anne", "Brown", 18, 7, 3.7);
	Student *thatStudentPtr = new Student ("Joe", "Schmoe", 17, 11.5, 3.2);

	cout << "This student: " << thisStudent << endl;
	cout << "That student pointer: " << *thatStudentPtr << endl;

	Person *thePersonPtr = thatStudentPtr;
	// This is legal, because Student is a kind of Person, so a Student pointer is
	// a kind of Person pointer.  Note that the reverse assignment,
	// Person *theStudentPtr = thePersonPtr;
	// wouldn't compile because a Person pointer is NOT "a kind of" Student pointer.

	cout << "Student Joe Schmoe as a Person: " << *thePersonPtr << endl;
	// Note that if Person::put() is declared as virtual, this will use
	// the Student version (complete with GPA); if you remove the word
	// "virtual" in front of the put() method in Person.h, this line
	// will use the Person version and not print Joe's GPA.

	// If the "put" method isn't labelled as "virtual", the compiler will
	// decide which version of the function to use based on the declared
	// type of the variable (in this case, thePersonPtr is declared as a
	// pointer to a Person, so it uses the Person version).  If the method
	// IS "virtual", the compiler will decide which version of the function
	// to use based on what type of thing the pointer is actually pointing
	// to (in this case, thePersonPtr is actually pointing to a Student, so
	// it uses the Student version).

	Person anne(thisStudent);
	cout << "Person variable anne: " << anne << endl;
	// Note that this will not print out a GPA, REGARDLESS of whether "put" is virtual.
	// Run-time polymorphism in C++ only works when you get at your objects through
	// pointers, not through direct variables.
}
